<template>
    <div
        v-if="pageReady"
        class="w-full"
    >
        <auto-form
            ref="form"
            :default-data="formModel"
            :hidden-data="{
                id: formModel.id ?? '',
            }"
            :fields="formFields"
        />
        <div class="flex justify-end space-x-2">
            <auto-button
                :block="false"
                :disabled="form && form.busy ? form.busy : false"
                @click="submitForm"
            >
                {{ $t('submit') }}
            </auto-button>
        </div>
    </div>
</template>
<script setup>
import AutoForm from "~/components/auto-form.vue";
import {computed, onMounted, ref} from "vue";
import {useI18n} from "vue-i18n";
import axios from "axios";
import AutoButton from "~/components/button/auto-button.vue";

const props = defineProps({
    formModel: {
        required: true,
        type: Object,
    }
});

const emit = defineEmits(['update']);

const $i18n = useI18n();
const pageReady = ref(false);
const form = ref();
const model = ref();
const groups = ref([]);

const formFields = computed(() => {
    return [
        {
            type: 'text',
            name: 'code',
            label: $i18n.t('code'),
            readonly: true,
            disabled: true
        },
        {
            type: 'text',
            name: 'plan_name',
            label: $i18n.t('plan_name'),
        },
        {
            type: 'file',
            name: 'upload_category_icon',
            label: $i18n.t('category_icon'),
            previewImage: model.value ? model.value.category_icon : '',
        },
        {
            type: 'file',
            name: 'upload_featured_photo',
            label: $i18n.t('featured_photo'),
            previewImage: model.value ? model.value.featured_photo : '',
        },
        {
            type: 'text',
            name: 'return_percentage_from',
            label: $i18n.t('return_percentage_from'),
        },
        {
            type: 'text',
            name: 'return_percentage_to',
            label: $i18n.t('return_percentage_to'),
        },
        {
            type: 'text',
            name: 'return_cycle',
            label: $i18n.t('return_cycle'),
        },
        {
            type: 'text',
            name: 'fund_size',
            label: $i18n.t('fund_size'),
        },
        {
            type: 'editor',
            name: 'fund_description',
            label: $i18n.t('fund_description'),
            uploadImageUrl: '/investment_plan/investment_plan/'
        },
    ]
});

const submitForm = async () => {
    try {
        const resp = await form.value.submitForm('/investment_plan/investment_plan/submit_form');

        if (resp.model) {
            emit('update', resp.model);
        }
    } catch (e) {
        console.log(e);
    }
};

onMounted(async () => {
    try {
        const data = await axios.post('/investment_plan/investment_plan/build_form', {
            id: props.formModel.id,
        });

        if (data.model) {
            model.value = {...data.model};
        }

        if (data.groups) {
            groups.value = data.groups;
        }

        pageReady.value = true;
    } catch (e) {
        console.log(e);
    }
});
</script>
